/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.76 Revision 1.132
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.76 2010/07/03 15:49:39 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.132 2012/06/07 15:36:49 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
21else 41 else
22 MY_P=qt-x11-opensource-src-${MY_PV} 42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
44 ;;
45esac
46
47IUSE="aqua debug pch"
48if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
49 IUSE+=" +exceptions"
23fi 50fi
51if version_is_at_least 4.8; then
52 IUSE+=" c++0x qpa"
53fi
24 54
25HOMEPAGE="http://qt.nokia.com/" 55DEPEND="virtual/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 56if [[ ${QT4_BUILD_TYPE} == live ]]; then
27 57 DEPEND+=" dev-lang/perl"
28LICENSE="|| ( LGPL-2.1 GPL-3 )" 58fi
29IUSE+=" debug pch aqua"
30 59
31RDEPEND=" 60RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 61 !<x11-libs/qt-assistant-${PV}:4
33 !>x11-libs/qt-assistant-${PV}-r9999 62 !>x11-libs/qt-assistant-${PV}-r9999:4
63 !<x11-libs/qt-bearer-${PV}:4
64 !>x11-libs/qt-bearer-${PV}-r9999:4
34 !<x11-libs/qt-core-${PV} 65 !<x11-libs/qt-core-${PV}:4
35 !>x11-libs/qt-core-${PV}-r9999 66 !>x11-libs/qt-core-${PV}-r9999:4
36 !<x11-libs/qt-dbus-${PV} 67 !<x11-libs/qt-dbus-${PV}:4
37 !>x11-libs/qt-dbus-${PV}-r9999 68 !>x11-libs/qt-dbus-${PV}-r9999:4
69 !<x11-libs/qt-declarative-${PV}:4
70 !>x11-libs/qt-declarative-${PV}-r9999:4
38 !<x11-libs/qt-demo-${PV} 71 !<x11-libs/qt-demo-${PV}:4
39 !>x11-libs/qt-demo-${PV}-r9999 72 !>x11-libs/qt-demo-${PV}-r9999:4
40 !<x11-libs/qt-gui-${PV} 73 !<x11-libs/qt-gui-${PV}:4
41 !>x11-libs/qt-gui-${PV}-r9999 74 !>x11-libs/qt-gui-${PV}-r9999:4
42 !<x11-libs/qt-multimedia-${PV} 75 !<x11-libs/qt-multimedia-${PV}:4
43 !>x11-libs/qt-multimedia-${PV}-r9999 76 !>x11-libs/qt-multimedia-${PV}-r9999:4
44 !<x11-libs/qt-opengl-${PV} 77 !<x11-libs/qt-opengl-${PV}:4
45 !>x11-libs/qt-opengl-${PV}-r9999 78 !>x11-libs/qt-opengl-${PV}-r9999:4
79 !<x11-libs/qt-openvg-${PV}:4
80 !>x11-libs/qt-openvg-${PV}-r9999:4
46 !<x11-libs/qt-phonon-${PV} 81 !<x11-libs/qt-phonon-${PV}:4
47 !>x11-libs/qt-phonon-${PV}-r9999 82 !>x11-libs/qt-phonon-${PV}-r9999:4
48 !<x11-libs/qt-qt3support-${PV} 83 !<x11-libs/qt-qt3support-${PV}:4
49 !>x11-libs/qt-qt3support-${PV}-r9999 84 !>x11-libs/qt-qt3support-${PV}-r9999:4
50 !<x11-libs/qt-script-${PV} 85 !<x11-libs/qt-script-${PV}:4
51 !>x11-libs/qt-script-${PV}-r9999 86 !>x11-libs/qt-script-${PV}-r9999:4
52 !<x11-libs/qt-sql-${PV} 87 !<x11-libs/qt-sql-${PV}:4
53 !>x11-libs/qt-sql-${PV}-r9999 88 !>x11-libs/qt-sql-${PV}-r9999:4
54 !<x11-libs/qt-svg-${PV} 89 !<x11-libs/qt-svg-${PV}:4
55 !>x11-libs/qt-svg-${PV}-r9999 90 !>x11-libs/qt-svg-${PV}-r9999:4
56 !<x11-libs/qt-test-${PV} 91 !<x11-libs/qt-test-${PV}:4
57 !>x11-libs/qt-test-${PV}-r9999 92 !>x11-libs/qt-test-${PV}-r9999:4
58 !<x11-libs/qt-webkit-${PV} 93 !<x11-libs/qt-webkit-${PV}:4
59 !>x11-libs/qt-webkit-${PV}-r9999 94 !>x11-libs/qt-webkit-${PV}-r9999:4
60 !<x11-libs/qt-xmlpatterns-${PV} 95 !<x11-libs/qt-xmlpatterns-${PV}:4
61 !>x11-libs/qt-xmlpatterns-${PV}-r9999 96 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
62" 97"
63 98
64S=${WORKDIR}/${MY_P} 99S=${WORKDIR}/${MY_P}
65 100
66# @FUNCTION: qt4-build_pkg_setup 101# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 102# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 103# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 104qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 105 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71 106
72 # Protect users by not allowing downgrades between releases 107 # Protect users by not allowing downgrades between releases
73 # Downgrading revisions within the same release should be allowed 108 # Downgrading revisions within the same release should be allowed
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 109 if has_version ">${CATEGORY}/${P}-r9999:4"; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 110 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
111 eerror
76 eerror "Sanity check to keep you from breaking your system:" 112 eerror "Sanity check to keep you from breaking your system:"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 113 eerror " Downgrading Qt is completely unsupported and will break your system!"
114 eerror
78 die "aborting to save your system" 115 die "aborting to save your system"
79 else 116 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 117 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 118 fi
82 fi 119 fi
83 120
84 if [[ "${PN}" == "qt-webkit" ]]; then 121 if [[ ${PN} == qt-webkit ]]; then
85 eshopts_push -s extglob 122 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([0-9])'; then 123 if is-flagq '-g?(gdb)?([1-9])'; then
87 echo 124 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)." 125 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage." 126 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug." 127 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
91 ewarn "For more info check out bug #307861" 128 ewarn "For more info check out bug #307861"
92 echo 129 echo
93 fi 130 fi
94 eshopts_pop 131 eshopts_pop
95 fi 132 fi
105 [[ ${CHOST} == *-apple-darwin* ]] && \ 142 [[ ${CHOST} == *-apple-darwin* ]] && \
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 143 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 144 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 145 fi
109 146
110 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3"
116 fi
117
118 if ! version_is_at_least 4.1 $(gcc-version); then 147 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!" 148 ewarn "Using a GCC version lower than 4.1 is not supported."
120 fi 149 fi
121} 150}
122 151
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 152# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
124# @DESCRIPTION: 153# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 154# Arguments for build_target_directories. Takes the directories in which the
126# code should be compiled. This is a space-separated list 155# code should be compiled. This is a space-separated list.
127 156
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 157# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION: 158# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt 159# Space-separated list including the directories that will be extracted from
131# tarball 160# Qt tarball.
132 161
133# @FUNCTION: qt4-build_src_unpack 162# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 163# @DESCRIPTION:
135# Unpacks the sources 164# Unpacks the sources.
136qt4-build_src_unpack() { 165qt4-build_src_unpack() {
137 setqtenv 166 setqtenv
138 local target targets= 167
168 case ${QT4_BUILD_TYPE} in
169 live)
170 git-2_src_unpack
171 ;;
172 release)
173 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 174 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 175 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 176 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
177 do
142 targets+=" ${MY_P}/${target}" 178 targets+="${MY_P}/${target} "
143 done 179 done
144 180
181 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 182 tar -xzf "${DISTDIR}/${tarball}" ${targets}
146 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 183 eend $? || die "failed to unpack"
184 ;;
185 esac
147} 186}
148 187
149# @ECLASS-VARIABLE: PATCHES 188# @ECLASS-VARIABLE: PATCHES
189# @DEFAULT_UNSET
150# @DESCRIPTION: 190# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure 191# PATCHES array variable containing all various patches to be applied.
152# to specify the full path. This variable is necessary for src_prepare phase. 192# This variable is expected to be defined in global scope of ebuild.
153# example: 193# Make sure to specify the full path. This variable is utilised in
154# PATCHES="${FILESDIR}"/mypatch.patch 194# src_unpack/src_prepare phase, based on EAPI.
155# ${FILESDIR}"/mypatch2.patch"
156# 195#
196# @CODE
197# PATCHES=( "${FILESDIR}/mypatch.patch"
198# "${FILESDIR}/patches_folder/" )
199# @CODE
157 200
158# @FUNCTION: qt4-build_src_prepare 201# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 202# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 203# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 204# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
162qt4-build_src_prepare() { 205qt4-build_src_prepare() {
163 setqtenv 206 setqtenv
164 cd "${S}"
165 207
166 # fix qt 4.7 regression that skips -fvisibility=hidden 208 if [[ ${QT4_BUILD_TYPE} == live ]]; then
209 QTDIR="." ./bin/syncqt || die "syncqt failed"
210 fi
211
167 if version_is_at_least "4.7.0_beta1"; then 212 if version_is_at_least 4.7; then
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \ 213 # fix libX11 dependency on non X packages
169 -i config.tests/unix/fvisibility.test || 214 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
170 die "visibility fixing sed failed" 215 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
216
217 qt_assistant_cleanup
171 fi 218 fi
172 219
173 if use aqua; then 220 if use aqua; then
174 # provide a proper macx-g++-64 221 # provide a proper macx-g++-64
175 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 222 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
176 223
177 sed -e '/^CONFIG/s:app_bundle::' \ 224 sed -e '/^CONFIG/s:app_bundle::' \
178 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 225 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
179 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 226 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
180 fi 227 fi
181 228
182 if [[ ${PN} != qt-core ]]; then 229 if [[ ${PN} != qt-core ]]; then
183 skip_qmake_build_patch 230 skip_qmake_build
184 skip_project_generation_patch 231 skip_project_generation
185 symlink_binaries_to_buildtree 232 symlink_binaries_to_buildtree
186 fi 233 fi
187 234
188 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 235 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
189 # qmake bus errors with -O2 but -O3 works 236 # qmake bus errors with -O2 or -O3 but -O1 works
237 # Bug 373061
190 replace-flags -O2 -O3 238 replace-flags -O[23] -O1
191 fi 239 fi
192 240
193 # Bug 178652 241 # Bug 178652
194 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 242 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
195 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 243 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
196 append-flags -fno-gcse 244 append-flags -fno-gcse
197 fi 245 fi
198 246
247 if use_if_iuse c++0x; then
248 echo
249 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
250 ewarn "this is an official standard, some of the reverse dependencies"
251 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
252 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
253 ewarn "disabled."
254 echo
255 append-flags -std=c++0x
256 fi
257
199 # Unsupported old gcc versions - hardened needs this :( 258 # Unsupported old gcc versions - hardened needs this :(
200 if [[ $(gcc-major-version) -lt 4 ]] ; then 259 if [[ $(gcc-major-version) -lt 4 ]]; then
201 ewarn "Appending -fno-stack-protector to CXXFLAGS" 260 ewarn "Appending -fno-stack-protector to CXXFLAGS"
202 append-cxxflags -fno-stack-protector 261 append-cxxflags -fno-stack-protector
203 # Bug 253127 262 # Bug 253127
204 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 263 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
205 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 264 -i mkspecs/common/g++.conf || die
206 fi 265 fi
207 266
208 # Bug 261632 267 # Bug 261632
209 if use ppc64; then 268 if use ppc64; then
210 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 269 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
211 append-flags -mminimal-toc 270 append-flags -mminimal-toc
212 fi 271 fi
213 272
214 # Bug 282984 && Bug 295530 273 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
215 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 274 sed -e "/^SYSTEM_VARIABLES=/i \
216 -i configure || die "sed qmake compilers failed" 275 CC='$(tc-getCC)'\n\
217 # bug 321335 276 CXX='$(tc-getCXX)'\n\
277 CFLAGS='${CFLAGS}'\n\
278 CXXFLAGS='${CXXFLAGS}'\n\
279 LDFLAGS='${LDFLAGS}'\n" \
280 -i configure \
281 || die "sed SYSTEM_VARIABLES failed"
282
283 # Respect CC, CXX, LINK and *FLAGS in config.tests
284 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
285 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
286 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
287 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
288 || die "sed config.tests failed"
289
218 if version_is_at_least 4.6; then 290 if ! version_is_at_least 4.8; then
219 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 291 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
220 xargs -0 \ 292 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
221 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):g" \
222 -i || die "sed test compilers failed"
223 fi 293 fi
224 294
225 # Bug 172219 295 # Bug 172219
226 sed -e "s:X11R6/::" \ 296 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
227 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
228 297
229 if [[ ${CHOST} == *-darwin* ]]; then 298 if [[ ${CHOST} == *-darwin* ]]; then
230 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 299 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
231 # crippled (by design) :/ 300 # crippled (by design) :/
301 local mac_gpp_conf=
302 if [[ -f mkspecs/common/mac-g++.conf ]]; then
303 # qt < 4.8 has mac-g++.conf
304 mac_gpp_conf="mkspecs/common/mac-g++.conf"
305 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
306 # qt >= 4.8 has g++-macx.conf
307 mac_gpp_conf="mkspecs/common/g++-macx.conf"
308 else
309 die "no known conf file for mac found"
310 fi
311 sed \
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 312 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 313 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 314 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
235 -e "s:-arch\s\w*::g" \ 315 -e "s:-arch\s\w*::g" \
236 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 316 -i ${mac_gpp_conf} \
317 || die "sed ${mac_gpp_conf} failed"
237 318
238 # Fix configure's -arch settings that appear in qmake/Makefile and also 319 # Fix configure's -arch settings that appear in qmake/Makefile and also
239 # fix arch handling (automagically duplicates our -arch arg and breaks 320 # fix arch handling (automagically duplicates our -arch arg and breaks
240 # pch). Additionally disable Xarch support. 321 # pch). Additionally disable Xarch support.
322 local mac_gcc_confs="${mac_gpp_conf}"
323 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
324 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
325 fi
241 sed \ 326 sed \
242 -e "s:-arch i386::" \ 327 -e "s:-arch i386::" \
243 -e "s:-arch ppc::" \ 328 -e "s:-arch ppc::" \
244 -e "s:-arch x86_64::" \ 329 -e "s:-arch x86_64::" \
245 -e "s:-arch ppc64::" \ 330 -e "s:-arch ppc64::" \
246 -e "s:-arch \$i::" \ 331 -e "s:-arch \$i::" \
247 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 332 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
248 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 333 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
249 -e "s:-Xarch_x86_64::g" \ 334 -e "s:-Xarch_x86_64::g" \
250 -e "s:-Xarch_ppc64::g" \ 335 -e "s:-Xarch_ppc64::g" \
251 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 336 -i configure ${mac_gcc_confs} \
337 || die "sed -arch/-Xarch failed"
252 338
253 # On Snow Leopard don't fall back to 10.5 deployment target. 339 # On Snow Leopard don't fall back to 10.5 deployment target.
254 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 340 if [[ ${CHOST} == *-apple-darwin10 ]]; then
255 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 341 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
256 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 342 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
257 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 343 -i configure ${mac_gpp_conf} \
344 || die "sed deployment target failed"
258 fi 345 fi
259 fi 346 fi
260 347
261 # this one is needed for all systems with a separate -liconv, apart from 348 # this one is needed for all systems with a separate -liconv, apart from
262 # Darwin, for which the sources already cater for -liconv 349 # Darwin, for which the sources already cater for -liconv
263 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 350 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
264 sed \ 351 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
265 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
266 -i config.tests/unix/iconv/iconv.pro \ 352 -i config.tests/unix/iconv/iconv.pro \
267 || die "sed on iconv.pro failed" 353 || die "sed iconv.pro failed"
268 fi 354 fi
269 355
270 # we need some patches for Solaris 356 # we need some patches for Solaris
271 sed -i \
272 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 357 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
273 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 358 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
274 # use GCC over SunStudio 359 # use GCC over SunStudio
275 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 360 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
276 # don't flirt with non-Prefix stuff, we're quite possessive 361 # do not flirt with non-Prefix stuff, we're quite possessive
277 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 362 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
278 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 363 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
279 # strip predefined CFLAGS from qmake ( bug #312689 )
280 sed -i '/^QMAKE_CFLAGS_\(RELEASE\|DEBUG\)/s:+=.*:+=:' mkspecs/common/g++.conf
281 364
282 base_src_prepare 365 base_src_prepare
283} 366}
284 367
285# @FUNCTION: qt4-build_src_configure 368# @FUNCTION: qt4-build_src_configure
286# @DESCRIPTION: 369# @DESCRIPTION:
287# Default configure phase 370# Default configure phase
288qt4-build_src_configure() { 371qt4-build_src_configure() {
289 setqtenv 372 setqtenv
290 myconf="$(standard_configure_options) ${myconf}" 373
374 local conf="
375 -prefix ${QTPREFIXDIR}
376 -bindir ${QTBINDIR}
377 -libdir ${QTLIBDIR}
378 -docdir ${QTDOCDIR}
379 -headerdir ${QTHEADERDIR}
380 -plugindir ${QTPLUGINDIR}
381 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
382 -datadir ${QTDATADIR}
383 -translationdir ${QTTRANSDIR}
384 -sysconfdir ${QTSYSCONFDIR}
385 -examplesdir ${QTEXAMPLESDIR}
386 -demosdir ${QTDEMOSDIR}
387 -opensource -confirm-license
388 -shared -fast -largefile -stl -verbose
389 -nomake examples -nomake demos"
390
391 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
392 # $(tc-arch). Therefore we convert it to supported values.
393 case "$(tc-arch)" in
394 amd64|x64-*) conf+=" -arch x86_64" ;;
395 ppc-macos) conf+=" -arch ppc" ;;
396 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
397 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
398 x86-macos) conf+=" -arch x86" ;;
399 x86|x86-*) conf+=" -arch i386" ;;
400 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
401 hppa|sh) conf+=" -arch generic" ;;
402 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
403 esac
404
405 conf+=" -platform $(qt_mkspecs_dir)"
406
407 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
408
409 # debug/release
410 if use debug; then
411 conf+=" -debug"
412 else
413 conf+=" -release"
414 fi
415 conf+=" -no-separate-debug-info"
416
417 # exceptions USE flag
418 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
419
420 # disable rpath on Qt >= 4.8 (bug 380415)
421 # but leave it enabled on prefix (bug 417169)
422 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
423
424 # precompiled headers don't work on hardened, where the flag is masked
425 conf+=" $(qt_use pch)"
426
427 # -reduce-relocations
428 # This flag seems to introduce major breakage to applications,
429 # mostly to be seen as a core dump with the message "QPixmap: Must
430 # construct a QApplication before a QPaintDevice" on Solaris.
431 # -- Daniel Vergien
432 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
291 433
292 # this one is needed for all systems with a separate -liconv, apart from 434 # this one is needed for all systems with a separate -liconv, apart from
293 # Darwin, for which the sources already cater for -liconv 435 # Darwin, for which the sources already cater for -liconv
294 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 436 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
295 myconf+=" -liconv" 437 conf+=" -liconv"
438 fi
296 439
297 if has glib ${IUSE//+} && use glib; then 440 if use_if_iuse glib; then
298 # use -I, -L and -l from configure
299 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 441 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
300 # avoid the -pthread argument 442 # avoid the -pthread argument
301 myconf+=" ${glibflags//-pthread}" 443 conf+=" ${glibflags//-pthread}"
302 unset glibflags 444 unset glibflags
303 fi 445 fi
304 446
447 if use_if_iuse qpa; then
448 echo
449 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
450 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
451 ewarn "disable it before reporting any bugs related to this useflag."
452 echo
453 conf+=" -qpa"
454 fi
455
305 if use aqua ; then 456 if use aqua; then
306 # On (snow) leopard use the new (frameworked) cocoa code. 457 # On (snow) leopard use the new (frameworked) cocoa code.
307 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 458 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
308 myconf+=" -cocoa -framework" 459 conf+=" -cocoa -framework"
460 # We need the source's headers, not the installed ones.
461 conf+=" -I${S}/include"
462 # Add hint for the framework location.
463 conf+=" -F${QTLIBDIR}"
309 464
310 # We are crazy and build cocoa + qt3support :-) 465 # We are crazy and build cocoa + qt3support :-)
311 if use qt3support; then 466 if use qt3support; then
312 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 467 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
313 -i configure 468 -i configure || die
314 fi 469 fi
315 470 else
316 # We need the source's headers, not the installed ones. 471 conf+=" -no-framework"
317 myconf+=" -I${S}/include"
318
319 # Add hint for the framework location.
320 myconf+=" -F${QTLIBDIR}"
321 fi 472 fi
322 else 473 else
323 # freetype2 include dir is non-standard, thus include it on configure 474 # freetype2 include dir is non-standard, thus pass it to configure
324 # use -I from configure
325 myconf+=" $(pkg-config --cflags freetype2)" 475 conf+=" $(pkg-config --cflags-only-I freetype2)"
326 fi 476 fi
327 477
478 conf+=" ${myconf}"
479 myconf=
480
328 echo ./configure ${myconf} 481 echo ./configure ${conf}
329 ./configure ${myconf} || die "./configure failed" 482 ./configure ${conf} || die "./configure failed"
330 myconf="" 483
484 prepare_directories ${QT4_TARGET_DIRECTORIES}
331} 485}
332 486
333# @FUNCTION: qt4-build_src_compile 487# @FUNCTION: qt4-build_src_compile
488# @DESCRIPTION:
334# @DESCRIPTION: Actual compile phase 489# Actual compile phase
335qt4-build_src_compile() { 490qt4-build_src_compile() {
336 setqtenv 491 setqtenv
337 492
338 build_directories ${QT4_TARGET_DIRECTORIES} 493 build_directories ${QT4_TARGET_DIRECTORIES}
339} 494}
340 495
341# @FUNCTION: qt4-build_src_test 496# @FUNCTION: qt4-build_src_test
342# @DESCRIPTION: 497# @DESCRIPTION:
343# Runs tests only in target directories. 498# Runs tests only in target directories.
344qt4-build_src_test() { 499qt4-build_src_test() {
500 # QtMultimedia does not have any test suite (bug #332299)
501 [[ ${PN} == qt-multimedia ]] && return
502
345 for dir in ${QT4_TARGET_DIRECTORIES}; do 503 for dir in ${QT4_TARGET_DIRECTORIES}; do
346 emake -j1 check -C ${dir} 504 emake -j1 check -C ${dir}
347 done 505 done
348} 506}
349 507
350# @FUNCTION: fix_includes 508# @FUNCTION: fix_includes
351# @DESCRIPTION: 509# @DESCRIPTION:
352# For MacOSX we need to add some symlinks when frameworks are 510# For MacOS X we need to add some symlinks when frameworks are
353# being used, to avoid complications with some more or less stupid packages. 511# being used, to avoid complications with some more or less stupid packages.
354fix_includes() { 512fix_includes() {
355 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 513 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
514 local frw dest f h rdir
356 # Some packages tend to include <Qt/...> 515 # Some packages tend to include <Qt/...>
357 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 516 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
358 517
359 # Fake normal headers when frameworks are installed... eases life later on 518 # Fake normal headers when frameworks are installed... eases life later
360 local dest f 519 # on, make sure we use relative links though, as some ebuilds assume
520 # these dirs exist in src_install to add additional files
521 f=${QTHEADERDIR}
522 h=${QTLIBDIR}
523 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
524 f=${f#*/}
525 h=${h#*/}
526 done
527 rdir=${h}
528 f="../"
529 while [[ ${h} == */* ]] ; do
530 f="${f}../"
531 h=${h#*/}
532 done
533 rdir="${f}${rdir}"
534
361 for frw in "${D}${QTLIBDIR}"/*.framework; do 535 for frw in "${D}${QTLIBDIR}"/*.framework; do
362 [[ -e "${frw}"/Headers ]] || continue 536 [[ -e "${frw}"/Headers ]] || continue
363 f=$(basename ${frw}) 537 f=$(basename ${frw})
364 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 538 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
365 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 539 dosym "${rdir}"/${f}/Headers "${dest}"
366 540
367 # Link normal headers as well. 541 # Link normal headers as well.
368 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 542 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
369 h=$(basename ${hdr}) 543 h=$(basename ${hdr})
370 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 544 dosym "../${rdir}"/${f}/Headers/${h} \
545 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
371 done 546 done
372 done 547 done
373 fi 548 fi
374} 549}
375 550
377# @DESCRIPTION: 552# @DESCRIPTION:
378# Perform the actual installation including some library fixes. 553# Perform the actual installation including some library fixes.
379qt4-build_src_install() { 554qt4-build_src_install() {
380 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 555 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
381 setqtenv 556 setqtenv
557
382 install_directories ${QT4_TARGET_DIRECTORIES} 558 install_directories ${QT4_TARGET_DIRECTORIES}
383 install_qconfigs 559 install_qconfigs
384 fix_library_files 560 fix_library_files
385 fix_includes 561 fix_includes
562
563 # remove .la files since we are building only shared Qt libraries
564 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
386} 565}
387 566
388# @FUNCTION: setqtenv 567# @FUNCTION: setqtenv
568# @INTERNAL
389setqtenv() { 569setqtenv() {
390 # Set up installation directories 570 # Set up installation directories
391 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
392 QTPREFIXDIR=${EPREFIX}/usr 571 QTPREFIXDIR=${EPREFIX}/usr
393 QTBINDIR=${EPREFIX}/usr/bin 572 QTBINDIR=${EPREFIX}/usr/bin
394 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 573 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
395 QMAKE_LIBDIR_QT=${QTLIBDIR}
396 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 574 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
397 QTDATADIR=${EPREFIX}/usr/share/qt4
398 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 575 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
399 QTHEADERDIR=${EPREFIX}/usr/include/qt4 576 QTHEADERDIR=${EPREFIX}/usr/include/qt4
400 QTPLUGINDIR=${QTLIBDIR}/plugins 577 QTPLUGINDIR=${QTLIBDIR}/plugins
578 QTIMPORTDIR=${QTLIBDIR}/imports
579 QTDATADIR=${EPREFIX}/usr/share/qt4
580 QTTRANSDIR=${QTDATADIR}/translations
401 QTSYSCONFDIR=${EPREFIX}/etc/qt4 581 QTSYSCONFDIR=${EPREFIX}/etc/qt4
402 QTTRANSDIR=${QTDATADIR}/translations
403 QTEXAMPLESDIR=${QTDATADIR}/examples 582 QTEXAMPLESDIR=${QTDATADIR}/examples
404 QTDEMOSDIR=${QTDATADIR}/demos 583 QTDEMOSDIR=${QTDATADIR}/demos
584 QMAKE_LIBDIR_QT=${QTLIBDIR}
405 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 585 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
586
406 PLATFORM=$(qt_mkspecs_dir) 587 PLATFORM=$(qt_mkspecs_dir)
407
408 unset QMAKESPEC 588 unset QMAKESPEC
409}
410 589
411# @FUNCTION: standard_configure_options 590 export XDG_CONFIG_HOME="${T}"
412# @DESCRIPTION:
413# Sets up some standard configure options, like libdir (if necessary), whether
414# debug info is wanted or not.
415standard_configure_options() {
416 local myconf=
417
418 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
419
420 # Disable visibility explicitly if gcc version isn't 4
421 if [[ $(gcc-major-version) -lt 4 ]]; then
422 myconf+=" -no-reduce-exports"
423 fi
424
425 # precompiled headers doesn't work on hardened, where the flag is masked.
426 myconf+=" $(qt_use pch)"
427
428 if use debug; then
429 myconf+=" -debug"
430 else
431 myconf+=" -release"
432 fi
433 myconf+=" -no-separate-debug-info"
434
435 use aqua && myconf+=" -no-framework"
436
437 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
438 # $(tc-arch). Therefore we convert it to supported values.
439 case "$(tc-arch)" in
440 amd64|x64-*) myconf+=" -arch x86_64" ;;
441 ppc-macos) myconf+=" -arch ppc" ;;
442 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
443 sparc|sparc-*) myconf+=" -arch sparc" ;;
444 x86-macos) myconf+=" -arch x86" ;;
445 x86|x86-*) myconf+=" -arch i386" ;;
446 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
447 hppa|sh) myconf+=" -arch generic" ;;
448 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
449 esac
450
451 # 4.5: build everything but qt-xmlpatterns w/o exceptions
452 # 4.6: exceptions USE flag
453 local exceptions="-exceptions"
454 case "${PV}" in
455 4.5.*)
456 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
457 ;;
458 *)
459 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
460 ;;
461 esac
462
463 # note about -reduce-relocations:
464 # That flag seems to introduce major breakage to applications,
465 # mostly to be seen as a core dump with the message "QPixmap: Must
466 # construct a QApplication before a QPaintDevice" on Solaris
467 # -- Daniel Vergien
468 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
469
470 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
471 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
472 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
473 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
474 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
475 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
476 ${exceptions}
477 -nomake examples -nomake demos"
478
479 echo "${myconf}"
480} 591}
481 592
482# @FUNCTION: build_directories 593# @FUNCTION: prepare_directories
483# @USAGE: < directories > 594# @USAGE: < directories >
595# @INTERNAL
484# @DESCRIPTION: 596# @DESCRIPTION:
485# Compiles the code in $QT4_TARGET_DIRECTORIES 597# Generates Makefiles for the given list of directories.
486build_directories() { 598prepare_directories() {
487 for x in "$@"; do 599 for x in "$@"; do
488 pushd "${S}"/${x} >/dev/null 600 pushd "${S}"/${x} >/dev/null || die
601 einfo "Running qmake in: ${x}"
489 # avoid running over the maximum argument number, bug #299810 602 # avoid running over the maximum argument number, bug #299810
490 { 603 {
491 echo "${S}"/mkspecs/common/*.conf 604 echo "${S}"/mkspecs/common/*.conf
492 find "${S}" -name '*.pr[io]' 605 find "${S}" -name '*.pr[io]'
493 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 606 } | xargs sed -i \
607 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
608 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
609 || die
494 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 610 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
611 popd >/dev/null || die
612 done
613}
614
615
616# @FUNCTION: build_directories
617# @USAGE: < directories >
618# @INTERNAL
619# @DESCRIPTION:
620# Compiles the code in the given list of directories.
621build_directories() {
622 for x in "$@"; do
623 pushd "${S}"/${x} >/dev/null || die
495 emake CC="$(tc-getCC)" \ 624 emake CC="$(tc-getCC)" \
496 CXX="$(tc-getCXX)" \ 625 CXX="$(tc-getCXX)" \
497 LINK="$(tc-getCXX)" || die "emake failed" 626 LINK="$(tc-getCXX)" || die "emake failed"
498 popd >/dev/null 627 popd >/dev/null || die
499 done 628 done
500} 629}
501 630
502# @FUNCTION: install_directories 631# @FUNCTION: install_directories
503# @USAGE: < directories > 632# @USAGE: < directories >
633# @INTERNAL
504# @DESCRIPTION: 634# @DESCRIPTION:
505# run emake install in the given directories, which are separated by spaces 635# Runs emake install in the given directories, which are separated by spaces.
506install_directories() { 636install_directories() {
507 for x in "$@"; do 637 for x in "$@"; do
508 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 638 pushd "${S}"/${x} >/dev/null || die
509 emake INSTALL_ROOT="${D}" install || die "emake install failed" 639 emake INSTALL_ROOT="${D}" install || die "emake install failed"
510 popd >/dev/null || die "Can't popd from ${S}/${x}" 640 popd >/dev/null || die
511 done 641 done
512} 642}
513 643
514# @ECLASS-VARIABLE: QCONFIG_ADD 644# @ECLASS-VARIABLE: QCONFIG_ADD
515# @DESCRIPTION: 645# @DESCRIPTION:
525# @DESCRIPTION: 655# @DESCRIPTION:
526# List variables that should be defined at the top of QtCore/qconfig.h 656# List variables that should be defined at the top of QtCore/qconfig.h
527: ${QCONFIG_DEFINE:=} 657: ${QCONFIG_DEFINE:=}
528 658
529# @FUNCTION: install_qconfigs 659# @FUNCTION: install_qconfigs
660# @INTERNAL
661# @DESCRIPTION:
530# @DESCRIPTION: Install gentoo-specific mkspecs configurations 662# Install gentoo-specific mkspecs configurations.
531install_qconfigs() { 663install_qconfigs() {
532 local x 664 local x
533 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 665 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
534 for x in QCONFIG_ADD QCONFIG_REMOVE; do 666 for x in QCONFIG_ADD QCONFIG_REMOVE; do
535 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 667 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
546 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 678 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
547 fi 679 fi
548} 680}
549 681
550# @FUNCTION: generate_qconfigs 682# @FUNCTION: generate_qconfigs
551# @DESCRIPTION: Generates gentoo-specific configurations 683# @INTERNAL
684# @DESCRIPTION:
685# Generates gentoo-specific qconfig.{h,pri}.
552generate_qconfigs() { 686generate_qconfigs() {
553 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 687 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
554 local x qconfig_add qconfig_remove qconfig_new 688 local x qconfig_add qconfig_remove qconfig_new
555 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 689 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
556 [[ -f ${x} ]] || continue 690 [[ -f ${x} ]] || continue
557 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 691 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
558 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 692 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
570 704
571 # generate list of QT_CONFIG entries from the existing list 705 # generate list of QT_CONFIG entries from the existing list
572 # including qconfig_add and excluding qconfig_remove 706 # including qconfig_add and excluding qconfig_remove
573 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 707 for x in $(sed -n 's/^QT_CONFIG +=//p' \
574 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 708 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
575 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 709 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
576 done 710 done
577 711
578 # replace the existing QT_CONFIG list with qconfig_new 712 # replace the existing QT_CONFIG list with qconfig_new
579 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 713 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
580 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 714 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
604 fi 738 fi
605 fi 739 fi
606} 740}
607 741
608# @FUNCTION: qt4-build_pkg_postrm 742# @FUNCTION: qt4-build_pkg_postrm
743# @DESCRIPTION:
609# @DESCRIPTION: Generate configurations when the package is completely removed 744# Regenerate configuration when the package is completely removed.
610qt4-build_pkg_postrm() { 745qt4-build_pkg_postrm() {
611 generate_qconfigs 746 generate_qconfigs
612} 747}
613 748
614# @FUNCTION: qt4-build_pkg_postinst 749# @FUNCTION: qt4-build_pkg_postinst
750# @DESCRIPTION:
615# @DESCRIPTION: Generate configuration, plus throws a message about possible 751# Regenerate configuration, plus throw a message about possible
616# breakages and proposed solutions. 752# breakages and proposed solutions.
617qt4-build_pkg_postinst() { 753qt4-build_pkg_postinst() {
618 generate_qconfigs 754 generate_qconfigs
619} 755}
620 756
621# @FUNCTION: skip_qmake_build_patch 757# @FUNCTION: skip_qmake_build
758# @INTERNAL
622# @DESCRIPTION: 759# @DESCRIPTION:
623# Don't need to build qmake, as it's already installed from qt-core 760# Patches configure to skip qmake compilation, as it's already installed by qt-core.
624skip_qmake_build_patch() { 761skip_qmake_build() {
625 # Don't need to build qmake, as it's already installed from qt-core
626 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 762 sed -i -e "s:if true:if false:g" "${S}"/configure || die
627} 763}
628 764
629# @FUNCTION: skip_project_generation_patch 765# @FUNCTION: skip_project_generation
766# @INTERNAL
630# @DESCRIPTION: 767# @DESCRIPTION:
631# Exit the script early by throwing in an exit before all of the .pro files are scanned 768# Exit the script early by throwing in an exit before all of the .pro files are scanned.
632skip_project_generation_patch() { 769skip_project_generation() {
633 # Exit the script early by throwing in an exit before all of the .pro files are scanned
634 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 770 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
635 -i "${S}"/configure || die "Sed failed"
636} 771}
637 772
638# @FUNCTION: symlink_binaries_to_buildtree 773# @FUNCTION: symlink_binaries_to_buildtree
774# @INTERNAL
639# @DESCRIPTION: 775# @DESCRIPTION:
640# Symlink generated binaries to buildtree so they can be used during compilation 776# Symlinks generated binaries to buildtree, so they can be used during compilation time.
641# time
642symlink_binaries_to_buildtree() { 777symlink_binaries_to_buildtree() {
643 for bin in qmake moc uic rcc; do 778 for bin in qmake moc uic rcc; do
644 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 779 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
645 done 780 done
646} 781}
647 782
648# @FUNCTION: fix_library_files 783# @FUNCTION: fix_library_files
784# @INTERNAL
649# @DESCRIPTION: 785# @DESCRIPTION:
650# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 786# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
651# moves the *.pc-files into the pkgconfig directory 787# moves the *.pc files into the pkgconfig directory.
652fix_library_files() { 788fix_library_files() {
789 local libfile
653 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 790 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
654 if [[ -e ${libfile} ]]; then 791 if [[ -e ${libfile} ]]; then
655 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 792 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
656 fi 793 fi
657 done 794 done
658 795
659 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 796 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
660 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 797 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
661 if [[ -e ${libfile} ]]; then 798 if [[ -e ${libfile} ]]; then
662 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 799 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
663 800
664 # Move .pc files into the pkgconfig directory 801 # Move .pc files into the pkgconfig directory
665 dodir ${QTPCDIR#${EPREFIX}} 802 dodir ${QTPCDIR#${EPREFIX}}
666 mv ${libfile} "${D}"/${QTPCDIR}/ \ 803 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
667 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
668 fi 804 fi
669 done 805 done
670 806
671 # Don't install an empty directory 807 # Don't install an empty directory
672 rmdir "${D}"/${QTLIBDIR}/pkgconfig 808 rmdir "${D}"/${QTLIBDIR}/pkgconfig
673} 809}
674 810
675# @FUNCTION: qt_use 811# @FUNCTION: qt_use
676# @USAGE: < flag > [ feature ] [ enableval ] 812# @USAGE: < flag > [ feature ] [ enableval ]
677# @DESCRIPTION: 813# @DESCRIPTION:
678# This will echo "${enableval}-${feature}" if <flag> is enabled, or 814# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
679# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 815# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
680# will be used for that. If [enableval] is not specified, it omits the 816# will be used for that. If [enableval] is not specified, it omits the
681# assignment-part 817# "-${enableval}" part.
682qt_use() { 818qt_use() {
683 local flag=$1 819 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
684 local feature=$1
685 local enableval=
686
687 [[ -n $2 ]] && feature=$2
688 [[ -n $3 ]] && enableval=-$3
689
690 if use ${flag}; then
691 echo "${enableval}-${feature}"
692 else
693 echo "-no-${feature}"
694 fi
695} 820}
696 821
697# @FUNCTION: qt_mkspecs_dir 822# @FUNCTION: qt_mkspecs_dir
698# @RETURN: the specs-directory w/o path 823# @RETURN: the specs-directory w/o path
699# @DESCRIPTION: 824# @DESCRIPTION:
700# Allows us to define which mkspecs dir we want to use. 825# Allows us to define which mkspecs dir we want to use.
701qt_mkspecs_dir() { 826qt_mkspecs_dir() {
702 # Allows us to define which mkspecs dir we want to use.
703 local spec 827 local spec=
704 828
705 case ${CHOST} in 829 case "${CHOST}" in
706 *-freebsd*|*-dragonfly*) 830 *-freebsd*|*-dragonfly*)
707 spec=freebsd ;; 831 spec=freebsd ;;
708 *-openbsd*) 832 *-openbsd*)
709 spec=openbsd ;; 833 spec=openbsd ;;
710 *-netbsd*) 834 *-netbsd*)
721 *-solaris*) 845 *-solaris*)
722 spec=solaris ;; 846 spec=solaris ;;
723 *-linux-*|*-linux) 847 *-linux-*|*-linux)
724 spec=linux ;; 848 spec=linux ;;
725 *) 849 *)
726 die "Unknown CHOST, no platform choosen." 850 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
727 esac 851 esac
728 852
729 CXX=$(tc-getCXX) 853 case "$(tc-getCXX)" in
730 if [[ ${CXX} == *g++* ]]; then 854 *g++*)
731 spec+=-g++ 855 spec+=-g++ ;;
732 elif [[ ${CXX} == *icpc* ]]; then 856 *icpc*)
733 spec+=-icc 857 spec+=-icc ;;
734 else 858 *)
735 die "Unknown compiler ${CXX}." 859 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
736 fi 860 esac
737 if [[ -n ${LIBDIR/lib} ]]; then
738 spec+=-${LIBDIR/lib}
739 fi
740 861
741 # Add -64 for 64bit profiles 862 # Add -64 for 64bit profiles
742 if use x64-freebsd || 863 if use x64-freebsd ||
743 use amd64-linux || 864 use amd64-linux ||
744 use x64-macos || 865 use x64-macos ||
749 fi 870 fi
750 871
751 echo "${spec}" 872 echo "${spec}"
752} 873}
753 874
875# @FUNCTION: qt_assistant_cleanup
876# @INTERNAL
877# @DESCRIPTION:
878# Tries to clean up tools.pro for qt-assistant ebuilds.
879# Meant to be called in src_prepare().
880# Since Qt 4.7.4 this function is a no-op.
881qt_assistant_cleanup() {
882 # apply patching to qt-assistant ebuilds only
883 [[ ${PN} != qt-assistant ]] && return
884
885 # no longer needed for 4.7.4 and later
886 version_is_at_least 4.7.4 && return
887
888 # different versions (and branches...) may need different handling,
889 # add a case if you need special handling
890 case "${MY_PV_EXTRA}" in
891 *kde-qt*)
892 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
893 -e "/mac/,/^embedded.*makeqpf$/d" \
894 -i tools/tools.pro || die "patching tools.pro failed"
895 ;;
896 *)
897 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
898 -e "/mac/,/^embedded.*makeqpf$/d" \
899 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
900 -i tools/tools.pro || die "patching tools.pro failed"
901 ;;
902 esac
903}
904
905# @FUNCTION: qt_nolibx11
906# @INTERNAL
907# @DESCRIPTION:
908# Ignore X11 tests for packages that don't need X libraries installed.
909qt_nolibx11() {
910 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
911 die "x11 check sed failed"
912}
913
754EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 914EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.76  
changed lines
  Added in v.1.132

  ViewVC Help
Powered by ViewVC 1.1.20